#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# import sensorsanalytics
import sdk

# 定义SensorsAnalytics 对象
sa={}
id_mapping={}

# 本地日志模式，示例：init_log('/data/sa/access.log')
def init_log(path):
    global consumer
    # consumer = sensorsanalytics.LoggingConsumer(path)
    consumer= sdk.ConcurrentLoggingConsumer(path, 1024)
    global sa
    sa = sdk.SensorsAnalytics(consumer)
    
    
# 网络日志模式，示例：init_server('http://server_ip',2)
def init_server(server,timeout):
    global consumer
    consumer = sdk.DefaultConsumer(server, timeout)
    global sa
    sa = sdk.SensorsAnalytics(consumer)


# 设置公共属性，示例：register_super_properties({'ServerVersion': '1.2','Location': 'Beijing'})
def register_common_properties(super_properties):
    sa.register_super_properties(super_properties)


# 事件跟踪，示例：track(distinct_id, 'ViewProduct', properties, is_login)
def not_login_track(distinct_id,event_name,properties):
    sa._no_track_event('track', event_name, distinct_id, distinct_id, properties, False)


def login_track(distinct_id,event_name,properties):
    original_id=id_mapping.get(distinct_id,distinct_id)
    sa._track_event('track', event_name, distinct_id, original_id, properties, True)

# ID关联
def track_signup(distinct_id, original_id):
    # 用户注册/登录时，将用户注册 ID 与 匿名 ID 关联
    sa.track_signup(distinct_id,original_id)
    id_mapping[distinct_id]=original_id

# 设置用户属性，示例：set_profile('ABCDEF123456789', {'Sex': 'Male','UserLevel': 'Elite VIP',}, True)
def set_user(distinct_id, properties):
    sa.profile_set(distinct_id, properties, True)

# 首次设置用户属性
def set_user_once(distinct_id, propeties):
    sa.profile_set_once(distinct_id, propeties)

# 列表类型的属性增加，示例：append_profile(distinct_id, {'Movies': ['Dead Poets Society']}, True)
def append_user(distinct_id, properties):
    sa.profile_append(distinct_id, properties, True)


# 属性增长，数字类型的属性值增加，示例：incr_profile(distinct_id, {'GamePlayed': 1}, True)
def incr_user(distinct_id, properties):
    sa.profile_increment(distinct_id, properties, True)

# 删除用户指定属性
def unset_user(distinct_id, profile_keys):
    sa.profile_unset(distinct_id,profile_keys,True)

# 删除用户所有属性
# def delete_user(distinct_id):
#     sa.profile_delete(distinct_id,True)

def flush():
    consumer.close()
    sa.flush()




